void disp7(byte w){
  if(w>=100){w=99;}
  byte h=0;
  if(stat.s.sevseg==1){
    if(w<10){
      h=w+240;
    }else{
      h=(w/10)*16+w%10;
    }
  }else if(stat.s.sevseg>1){
    h=(w/10)*16+w%10;
  }else{
    h=255;
  }
  if(dispen==0){h=255;}
  for(byte i=0;i<=7;i++){
    digitalWrite(i+2,bitRead(h,i));
  }
}

byte userButtons(){
  byte t = 0;
  for(byte i=14;i<=17;i++){ bitWrite(t,i-14,!digitalRead(i)); }
  return t;
}


float enterCoord(float t){
  //stat.s.mode++;
  byte p=0; //position
  byte k=0; //key
  do{
  lcd.cursor();
  printCoord(t);
  lcd.setCursor(p,1); 
  delay(10);while(userButtons()!=0){};delay(10);
  k=0;while(k==0){k=userButtons();}
  //disp7(k);
  if(k==8){p++;} if(p>10){p=0;}
  switch(p){
    case 0:
      if(k==2||k==4){t=-t;}
      break;
    case 1:
      if(k==2){t+=100;}
      if(k==4){t-=100;}
      break;
    case 2:
      if(k==2){t+=10;}
      if(k==4){t-=10;}
      break;
    case 3:
      if(k==2){t+=1;}
      if(k==4){t-=1;}
      break;
    case 5:
      if(k==2){t+=.1;}
      if(k==4){t-=.1;}
      break;
    case 6:
      if(k==2){t+=.01;}
      if(k==4){t-=.01;}
      break;
    case 7:
      if(k==2){t+=.001;}
      if(k==4){t-=.001;}
      break;
    case 8:
      if(k==2){t+=.0001;}
      if(k==4){t-=.0001;}
      break;
    case 9:
      if(k==2){t+=.00001;}
      if(k==4){t-=.00001;}
      break;
    case 10:
      if(k==2){t+=.000001;}
      if(k==4){t-=.000001;}
      break;
    }
  }while(k!=1);
  lcd.noCursor();
  return t;
}
void printCoord(float t){
  line2clear();
  if(t>=0){lcd.print('+');}else{lcd.print('-');}
  if(abs(t)<10){lcd.print('0');}
  if(abs(t)<100){lcd.print('0');}
  lcd.print(abs(t),6);lcd.write(223);
}

byte enterByte(byte t){
  //stat.s.mode++;
  byte k=0; //key
  do{
  lcd.cursor();
  line2clear();
  lcd.print(t);
  delay(10);while(userButtons()!=0){};delay(10);
  k=0;while(k==0){k=userButtons();}
  //disp7(k);
  if(k==2){t++;}
  if(k==4){t--;}
  
  }while(k!=1);
  lcd.noCursor();
  return t;
}

void line2clear(){
   lcd.setCursor(0,1);
   lcd.print(F("                "));
   lcd.setCursor(0,1);
}

void applySettings(){
  saveSettings();
  if(stat.s.backlt>0){lcd.backlight();}else{lcd.noBacklight();}
}

void saveSettings(){
  stat.s.hourmeter=opening_hourmeter+millis()/1000;
  ramcycle++; if(ramcycle>=4){ramcycle=0;}
  stat.s.checksum=CRC8(stat.b, sizeof(stat.b)-1);
  for(byte i=0; i<sizeof(nonvol_t); i++){
    ram.write(i+128*ramcycle, stat.b[i]);
  }
}

byte readSettings(){
  byte used=0;
  uint32_t hpicker[4];
  for(byte j=0; j<4; j++){
    for(byte i=0; i<sizeof(nonvol_t); i++){
      stat.b[i]=ram.read(i+128*j);
    }
    if(stat.s.checksum==CRC8(stat.b, sizeof(stat.b)-1)){
      hpicker[j]=stat.s.hourmeter;
    }else{
      hpicker[j]=0;
    }
  }

  uint32_t max_v = 0;
  for(byte i=0;i<sizeof(hpicker)/sizeof(hpicker[0]); i++){
    if(hpicker[i] >= max_v){
      max_v = hpicker[i];
      used = i;
    }
  }
  ramcycle=used;
  return used;
}

byte CRC8(const byte *data, byte len) {
  //CRC-8 - based on the CRC8 formulas by Dallas/Maxim
  //code released under the therms of the GNU GPL 3.0 license
  byte crc = 0x00;
  while (len--) {
    byte extract = *data++;
    for (byte tempI = 8; tempI; tempI--) {
      byte sum = (crc ^ extract) & 0x01;
      crc >>= 1;
      if (sum) {
        crc ^= 0x8C;
      }
      extract >>= 1;
    }
  }
  return crc;
}

//********************************************GPS CALCULATIONS********************************************
void integrateSpeed(){
  long temp = millis();
  if(pmillis!=temp){
    long diff = temp-pmillis;
    pmillis=temp;
    float ztemp = gps.speed.mps()*1000; //millimeters/s
    if(gps.speed.mph()>=4){
      stat.s.odometer += ztemp*diff; //milli-milli-meters
      stat.s.trip1 += ztemp*diff;
      stat.s.trip2 += ztemp*diff;
      stat.s.trip3 += ztemp*diff;
      stat.s.trip4 += ztemp*diff;
      tripPwrOn += ztemp*diff;
    }
  }
}

void distang(float tlat, float tlng){
  float dist = TinyGPSPlus::distanceBetween(gps.location.lat(), gps.location.lng(), tlat, tlng)*0.000621371; 
  float crse = TinyGPSPlus::courseTo(       gps.location.lat(), gps.location.lng(), tlat, tlng);
  float gdir = gps.course.deg(); if(crse>180){crse=crse-360;} if(gdir>180){gdir=gdir-360;}
  float dwsn = gdir - crse; if(dwsn>180){dwsn=dwsn-360;}if(dwsn<-180){dwsn=dwsn+360;}; //make direction variable

  lcd.clear();
  lcd.print(F("D:"));lcd.print(dist, 3);lcd.print(F(" mi"));lcd.setCursor(0,1);
  lcd.print(F("A:"));lcd.print(dwsn, 2);lcd.write(223); //degree sign; 
}

void smartDelay(unsigned long ms){         //delay and read gps at same time
  unsigned long start = millis();
  do {
    while (ss.available()){
      gps.encode(ss.read());
      yield();
    }
    integrateSpeed();
  } while (millis() - start < ms);
}
